function controlSocketConnect(manual) {
	document.getElementById('host').value = document.getElementById('host').value.replace(/^ftp:\/*/, '');	// error checking - get rid of 'ftp://'
	var host = document.getElementById("host").value;

	if (host == "about:mozilla") {															// just for fun
		window.openDialog("chrome://fireftp/content/welcomeDialog.xul","welcomeDialog",
			"screenY=0,screenX=0,width=" + document.getElementById('main-window').boxObject.width
		   +",height=" + document.getElementById('main-window').boxObject.height +
			",chrome,modal=no,dialog=yes,resizable=yes", welcomeMessage, true);
		gConnectButton.label = "Flame On!";
		gConnectButton.setAttribute('accesskey', "F");
		return;
	}

	if (!host) {																			// need to fill in the host
		window.openDialog("chrome://fireftp/content/alertDialog.xul","alertDialog",
			"screenY="+(document.getElementById('main-window').boxObject.height/2 - 100+document.getElementById('main-window').boxObject.screenY)
		   +",screenX="+(document.getElementById('main-window').boxObject.width/2 - 200+document.getElementById('main-window').boxObject.screenX)+
			",width=400,height=200,chrome,modal=yes,dialog=yes,resizable=yes", strbundle.getString("alertFillHost"));
		return;
	}
	if (!port || !parseInt(port)) {															// need a valid port
		window.openDialog("chrome://fireftp/content/alertDialog.xul","alertDialog",
			"screenY="+(document.getElementById('main-window').boxObject.height/2 - 10+document.getElementById('main-window').boxObject.screenY)
		   +",screenX="+(document.getElementById('main-window').boxObject.width/2 - 200+document.getElementById('main-window').boxObject.screenX)+
			",width=400,height=200,chrome,modal=yes,dialog=yes,resizable=yes", strbundle.getString("alertFillPort"));
		return;
	}
	
	document.getElementById('statusbytes').label = strbundle.getString("connecting");		// update status bar
	document.getElementById('statusmeter').setAttribute("mode", "undetermined");
	gConnectButton.label = strbundle.getString("disconnectButton");
	gConnectButton.setAttribute('command','cmd_disconnect');
	gConnectButton.setAttribute('accesskey', strbundle.getString("disconnectAccess"));

	if (!eventQueue.length || eventQueue[0].cmd != "welcome")								// wait for welcome message first
		eventQueue.unshift( { cmd: "welcome", parameter: "", remember: "" } );

	if (manual) {																			// this is a reconnection attempt
		isReconnecting = false;
		reconnectAttempts = parseInt(attempts);
		if (!reconnectAttempts || reconnectAttempts < 1)
			reconnectAttempts = 1;
	}

	try {																					// create a control socket
		var transportService =
	      Components.classes["@mozilla.org/network/socket-transport-service;1"]
    	    .getService(Components.interfaces.nsISocketTransportService);

		var proxyInfo = null;

		if (proxymode) {																	// use a proxy
			var prefs = Components.classes["@mozilla.org/preferences-service;1"].
				getService(Components.interfaces.nsIPrefService);
			var prefBranch = prefs.getBranch("network.proxy.");

			var proxyService = Components.classes["@mozilla.org/network/protocol-proxy-service;1"]
				.getService(Components.interfaces.nsIProtocolProxyService);
			var socksver = prefBranch.getIntPref("socks_version");							// thanks to Erik Anderson
			if (socksver == 5) { 
				proxyInfo = proxyService.newProxyInfo("socks", prefBranch.getCharPref("ftp"), prefBranch.getIntPref("ftp_port")); 
			} else { 
				proxyInfo = proxyService.newProxyInfo("socks" + socksver, prefBranch.getCharPref("ftp"), prefBranch.getIntPref("ftp_port")); 
			}
		}

		var control_transport;
		if (sslmode)
			control_transport = transportService.createTransport(["ssl"],1,host,parseInt(port),proxyInfo);	// XXX ssl doesn't work
		else
			control_transport = transportService.createTransport(null,0,host,parseInt(port),proxyInfo);

		control_outstream = control_transport.openOutputStream(0,0,0);
		var control_stream = control_transport.openInputStream(0,0,0);
		control_instream = Components.classes["@mozilla.org/scriptableinputstream;1"]
			.createInstance(Components.interfaces.nsIScriptableInputStream);
		control_instream.init(control_stream);

		var dataListener = {																// async data listener for the control socket
			data : "",
			onStartRequest: function(request, context) {},
			onStopRequest: function(request, context, status) {
				if (!isConnected)															// no route to host
					appendLog(strbundle.getString("errorConn"), 'color:red;font-weight:bold;');
				isConnected = false;

				document.getElementById('statusbytes').label = "";							// update status bar
				document.getElementById('statuselapsed').label = "";
				document.getElementById('statusremaining').label = "";
				document.getElementById('statusrate').label = "";
				document.getElementById('statusmeter').setAttribute("mode", "determined");
				document.getElementById('statusmeter').setAttribute("value", "0%");
				gConnectButton.label = strbundle.getString("connectButton");
				gConnectButton.setAttribute('command','cmd_connect');
				gConnectButton.setAttribute('accesskey', strbundle.getString("connectAccess"));

				if (!legitClose && timeoutmode) {											// try reconnecting
					isReconnecting = true;
					var seconds = parseInt(retry);
					if (!seconds || seconds < 1)
						seconds = 1;
					document.getElementById('statusbytes').label =
						strbundle.getString("reconnect") + ' ' + seconds + ' ' + strbundle.getString("seconds") +
						' ' + reconnectAttempts + ' ' + strbundle.getString("attempts");
					document.getElementById('statusmeter').setAttribute("mode", "undetermined");
					setTimeout("tryReconnect()", seconds * 1000);
				} else
					eventQueue = new Array;
			},
			onDataAvailable: function(request, context, inputStream, offset, count) {
				this.data = control_instream.read(count);									// read data
				readControl(this.data);
			},
		};

		var pump = Components.classes["@mozilla.org/network/input-stream-pump;1"].
			createInstance(Components.interfaces.nsIInputStreamPump);
		pump.init(control_stream, -1, -1, 0, 0, false);
		pump.asyncRead(dataListener,null);

	} catch(ex) {
		error(strbundle.getString("errorConn"));
		debug(ex,12);
		return;
	}
}
function tryReconnect()	{ // ahhhh! our precious connection has been lost, must...get it...back...our...precious
	if (!isReconnecting) {
		document.getElementById('statusbytes').label = "";
		document.getElementById('statusmeter').setAttribute("mode", "determined");
		document.getElementById('statusmeter').setAttribute("value", "0%");
		return;
	}

	--reconnectAttempts;
	if (reconnectAttempts < 0) {
		document.getElementById('statusbytes').label = "";
		document.getElementById('statusmeter').setAttribute("mode", "determined");
		document.getElementById('statusmeter').setAttribute("value", "0%");
		return;
	}
	
	controlSocketConnect();
}
function disconnect() {
	// haven't connected yet, changed our minds and decided to invade canada instead (just playin' canada...naw, i'm serious)
	if (!isConnected && eventQueue.length && eventQueue[0].cmd == "welcome") {
		document.getElementById('statusbytes').label = "";
		document.getElementById('statusmeter').setAttribute("mode", "determined");
		document.getElementById('statusmeter').setAttribute("value", "0%");
		gConnectButton.label = strbundle.getString("connectButton");
		gConnectButton.setAttribute('command','cmd_connect');
		gConnectButton.setAttribute('accesskey', strbundle.getString("connectAccess"));
		eventQueue = new Array;

		try {																	// try closing everything
			control_instream.close();
		} catch(ex) { debug(ex,1); }
		try {
			control_outstream.close();
		} catch(ex) { debug(ex,2); }
	} else if (isConnected) {
		if (eventQueue.length)
			if (!confirm(strbundle.getString("reallyclose")))
				return;
		legitClose = true;														// this close() is ok, don't try to reconnect
		gRemotePath.value = '/';
		remotePathFocus = '/';
		close();
	}
}
function addEventQueue(cmd, parameter, remember) {								// this just creates a new queue item
	parameter = parameter ? parameter : '';
	remember = remember ? remember : '';
	eventQueue.push( { cmd: cmd, parameter: parameter, remember: remember } );
}
function writeControl(cmd, parameter) {
	try {
		if (cmd == "aborted" || cmd == "goodbye") {								// these are sort of dummy values
			eventQueue.shift();
			if (eventQueue.length) {
				cmd = eventQueue[0].cmd;
				parameter = eventQueue[0].parameter;
			} else
				return;
		}

		isReady = false;
		if (cmd != "QUIT") {
			document.getElementById('statusbytes').label = strbundle.getString("working");
			document.getElementById('statusmeter').setAttribute("mode", "undetermined");
		} else {
			document.getElementById('statusbytes').label = "";
			document.getElementById('statusmeter').setAttribute("mode", "determined");
			document.getElementById('statusmeter').setAttribute("value", "0%");
		}
		var filesleft = 0;														// update status bar to list how many files are left
		for (var x = 0; x < eventQueue.length; ++x)
			if (eventQueue[x].cmd == "RETR" || eventQueue[x].cmd == "APPE"
					|| eventQueue[x].cmd == "STOR" || eventQueue[x].cmd == "DELE" || eventQueue[x].cmd == "RMD")
			++filesleft;
		if (filesleft)
			document.getElementById('statusbytes').label +=
				' - ' + filesleft + ' ' + strbundle.getString("filesleft");
		if (!pasvmode && cmd == "PASV") {										// active mode
			cmd = "PORT";
			activeConnected = false;
			try {
				var DNSService = Components.classes["@mozilla.org/network/dns-service;1"]
						.getService(Components.interfaces.nsIDNSService);
				var ipAddress = DNSService.resolve(DNSService.myHostName, false).getNextAddrAsString();
				var re = /\x2e/g;
				var serverSocket = Components.classes["@mozilla.org/network/server-socket;1"]
						.createInstance(Components.interfaces.nsIServerSocket);
				var serverListener = {
					onSocketAccepted: function(serv, transport) {
						data_transport = transport;
						if (activeCmd == "LIST")
							dataSocketConnect(false, '', 0, 0, transport);
						else if (activeCmd == "RETR")
							dataSocketConnect(false, activeRemember, activeRemember2, 0, transport);
						else if (activeCmd == "REST")
							dataSocketConnect(false, activeRemember, activeRemember2, activeRemember3, transport);
						else if (activeCmd == "STOR")
							dataSocketConnect(true, activeRemember, 0, 0, transport);
						else if (activeCmd == "APPE")
							dataSocketConnect(true, activeRemember, 0, activeRemember2, transport);
					},
					onStopListening: function(serv, status) {}
				};
				serverSocket.init(-1, false, -1);
				serverSocket.asyncListen(serverListener);
				parameter = ipAddress.replace(re, ",") + "," + parseInt(serverSocket.port / 256) + "," + serverSocket.port % 256;
			} catch (ex) { 
				error(strbundle.getString("errorDataConn"));
				debug(ex,13);
				return;
			}
		}
		if (cmd == "LIST")														// don't include path in list command - breaks too many things
			parameter = hiddenmode ? "-al" : "";
		var outputData = cmd + (parameter ? (' ' + parameter) : '') + "\r\n";	// thanks to devin
		control_outstream.write(outputData,outputData.length);					// write!

		++networkTimeoutID;														// this checks for timeout
		var seconds = parseInt(network);
		if (!seconds || seconds < 1)
			seconds = 1;
		setTimeout("checkTimeout(" + networkTimeoutID + ",'" + cmd + "')", seconds * 1000);
		
		outputData = cmd + (parameter ? (' ' + parameter) : '');				// write it out to the log
		if (cmd != "PASS")
			appendLog("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" + outputData, 'color:blue');
		else
			appendLog("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;PASS " + strbundle.getString("passNotShown"), 'color:blue');
	} catch(ex) {
		error(strbundle.getString("errorConn"));
		debug(ex,14);
	}
}
function readControl(buffer) {
	if (buffer == "2" && !isConnected)
		return;
	var lastLineOfBuffer = buffer.split("\r\n");

	if (buffer != "2") { 													// "2"s are self-generated fake messages
		for (var x = 0; x < lastLineOfBuffer.length; ++x) {					// add response to log
			var message = lastLineOfBuffer[x].charAt(lastLineOfBuffer[x].length - 1) == '\r'
					? lastLineOfBuffer[x].substring(0, lastLineOfBuffer[x].length - 1) : lastLineOfBuffer[x];
			appendLog(message, lastLineOfBuffer[x].charAt(0) == '4' || lastLineOfBuffer[x].charAt(0) == '5'
					? 'color:red;font-weight:bold' : 'color:green');
		}
	}
	
	lastLineOfBuffer = lastLineOfBuffer[lastLineOfBuffer.length - 1];		// we are only interested in what the last line says
	var returnCode;

																			// see if the message is finished or not
	if ((lastLineOfBuffer.length > 3 && lastLineOfBuffer.charAt(3) == '-') || lastLineOfBuffer.charAt(0) == ' ') {
		if (eventQueue[0].cmd == "USER" || eventQueue[0].cmd == "PASS")
			welcomeMessage += buffer;
		return;
	} else
		returnCode = parseInt(lastLineOfBuffer.charAt(0));					// looks at first number of number code

	var cmd;	var parameter;		var remember;

	if (eventQueue.length) {
		cmd = eventQueue[0].cmd;
		parameter = eventQueue[0].parameter;
		remember = eventQueue[0].remember;
		if (cmd != "LIST" && cmd != "RETR" && cmd != "STOR" && cmd != "APPE" &&
			cmd != "LIST2" && cmd != "RETR2" && cmd != "STOR2" && cmd != "APPE2") {	// used if we have a loss in connection
			var throwAway = eventQueue.shift();
			if (throwAway.cmd != "USER" && throwAway.cmd != "PASS" && throwAway.cmd != "PWD" &&
					throwAway.cmd != "welcome" && throwAway.cmd != "goodbye" && throwAway.cmd != "aborted")
				trashQueue.push(throwAway);
			if (trashQueue.length > 4)										// don't remember too much junk
				trashQueue.shift();
		}
	} else
		cmd = "default";													// an unexpected reply - perhaps a 421 timeout message

	switch (cmd) {
		case "welcome":
			welcomeMessage = buffer;
			
			if (returnCode != 2) {
				displayWelcomeMessage();									// not so welcome, failed before login
				eventQueue = new Array;
				addEventQueue("welcome");
				gConnectButton.label = strbundle.getString("connectButton");
				gConnectButton.setAttribute('command','cmd_connect');
				gConnectButton.setAttribute('accesskey', strbundle.getString("connectAccess"));
				document.getElementById('login').focus();
				break;
			}
			
			isConnected = true;												// good to go
			reconnectAttempts = parseInt(attempts);							// setup reconnection settings
			if (!reconnectAttempts || reconnectAttempts < 1)
				reconnectAttempts = 1;

			var host = document.getElementById("host").value;				// get the favicon - just for kicks
			if (host.indexOf("ftp.") == 0)
				host = host.substring(4);
			document.getElementById('favicon').src = "http://" + host + "/favicon.ico";

			initialPath = gRemotePath.value;								// save the path (and the seamonkeys)

			if (!document.getElementById('login').value)					// send username ('anonymous' if field blank)
				document.getElementById('login').value = "anonymous";
			eventQueue.unshift( { cmd: "USER", parameter: document.getElementById('login').value, remember: "" } );
			break;
		case "USER":
		case "PASS":
			if (returnCode == 2) {
				welcomeMessage += buffer;
				if (legitClose)
					displayWelcomeMessage();								// hello world only if it's not a reconnection attempt
				saveSession();

				if (!legitClose) {
					recoverFromDisaster();									// recover from previous disaster
					break;
				}
				legitClose = false;
				remotePathFocus = '/';
				gRemotePath.value = initialPath;							// navigate to a directory

				eventQueue.unshift( { cmd: "PWD", parameter: "", remember: "" } );
			} else if (cmd == "USER" && returnCode == 3) {
				if (!document.getElementById('password').value)				// send password (mozilla@example.com if field blank)
					document.getElementById('password').value = "mozilla@example.com";
				eventQueue.unshift( { cmd: "PASS", parameter: document.getElementById('password').value, remember: "" } );
			} else {
				eventQueue = new Array;										// login failed, cleanup variables
				addEventQueue("welcome");
				error(buffer, true);
				gConnectButton.label = strbundle.getString("connectButton");
				gConnectButton.setAttribute('command','cmd_connect');
				gConnectButton.setAttribute('accesskey', strbundle.getString("connectAccess"));
				document.getElementById('login').focus();
				return;
			}
			break;
		case "PASV":
			if (returnCode != 2) {
				error(buffer, true);
				break;
			}

			emptyFileSoCloseLater = false;									// files that are empty are special cases
			if (pasvmode) {
				buffer = buffer.substring(buffer.indexOf("(") + 1, buffer.indexOf(")"));

				var re = /,/g;
				buffer = buffer.replace(re,".");							// parsing the port to transfer to
				dataport = parseInt(buffer.substring(buffer.lastIndexOf(".") + 1));
				dataport += 256 * parseInt(buffer.substring(buffer.lastIndexOf(".", buffer.lastIndexOf(".") - 1) + 1, buffer.lastIndexOf(".") + 1));
				datahost = buffer.substring(0, buffer.lastIndexOf(".", buffer.lastIndexOf(".") - 1));

				if (eventQueue[0].cmd == "LIST")							// do what's appropriate
					dataSocketConnect();
				else if (eventQueue[0].cmd == "RETR")
					dataSocketConnect(false, eventQueue[0].remember, remember);
				else if (eventQueue[0].cmd == "REST")
					dataSocketConnect(false, eventQueue[1].remember, remember, eventQueue[0].parameter);
				else if (eventQueue[0].cmd == "STOR")
					dataSocketConnect(true, eventQueue[0].remember, 0, 0);
				else if (eventQueue[0].cmd == "APPE")
					dataSocketConnect(true, eventQueue[0].remember[0], 0, eventQueue[0].remember[1]);
			} else {
				activeCmd = eventQueue[0].cmd;								// passive mode turned off
				if (eventQueue[0].cmd == "LIST")
					remember = remember ? remember : false;
				else if (eventQueue[0].cmd == "RETR") {
					activeRemember = eventQueue[0].remember;
					activeRemember2 = remember;
				} else if (eventQueue[0].cmd == "REST") {
					activeRemember = eventQueue[1].remember;
					activeRemember2 = remember;
					activeRemember3 = eventQueue[0].parameter;
				} else if (eventQueue[0].cmd == "STOR")
					activeRemember = eventQueue[0].remember;
				else if (eventQueue[0].cmd == "APPE") {
					activeRemember = eventQueue[0].remember[0];
					activeRemember2 = eventQueue[0].remember[1];
				}
			}
			break;
		case "APPE":
		case "LIST":
		case "RETR":
		case "STOR":
			if (cmd == "STOR" && emptyFileSoCloseLater) {					// empty files are special cases
				try {
					data_transport.close("Finished");
				} catch (ex) { debug(ex,42); }
			}
			eventQueue[0].cmd = cmd + "2";
			if (returnCode == 2) {
				if (data_finished) {
					var throwAway = eventQueue.shift();
					trashQueue.push(throwAway);
					if (trashQueue.length > 4)								// don't remember too much junk
						trashQueue.shift();
					if (cmd == "LIST") {
						data = parseListData(data, hiddenmode ? parameter.substring(4, parameter.length) : parameter);
						eval(remember);										// send off list data to whoever wanted it
					}
					break;
				} else {
					setTimeout("readControl(\"2\")", 500);					// give data stream some time to finish up
					return;
				}
			}
			if (returnCode != 1) {
				error(buffer, true);
				eventQueue.shift();
				break;
			}
			return;
		case "APPE2":
		case "RETR2":
		case "STOR2":
		case "LIST2":
			if (returnCode != 2) {
				if (cmd != "RETR2" && buffer.substring(0,3) != "450")		// "450" errors are ok (i don't remember why though... :(
					error(buffer, true);
				eventQueue.shift();
				break;
			}
			
			if (data_finished) {
				var throwAway = eventQueue.shift();
				trashQueue.push(throwAway);
				if (trashQueue.length > 4)								// don't remember too much junk
					trashQueue.shift();
			}

			if (cmd == "LIST2" && data_finished) {
				data = parseListData(data, hiddenmode ? parameter.substring(4, parameter.length) : parameter);
				eval(remember);												// send off list data to whoever wanted it
			}
			else if (!data_finished) {
				//eventQueue.unshift( { cmd: cmd, parameter: parameter, remember: remember } ); // thanks to Michael Kraft
				setTimeout("readControl(\"2\")", 500);						// give data stream some time to finish up
				return;
			}
			break;
		case "SIZE":
			if (returnCode == 2) {											// used with appe commands to see where to pick up from
				var size = buffer.split(" ");
				size = parseInt(size[1]);
				for (var x = 0; x < eventQueue.length; ++x)
					if (remember == eventQueue[x].cmd) {
						if (remember == "STOR") {
							eventQueue[x].cmd = "APPE";
							eventQueue[x].remember = new Array(eventQueue[x].remember, size);
						}
						if (remember == "APPE")
							eventQueue[x].remember = new Array(eventQueue[x].remember[0], size);
						break;
					}
			}
			break;
		case "RNFR":
		case "REST":
			if (returnCode != 3) {
				if (cmd == "RNFR")
					eventQueue = new Array;
				error(buffer, true);										// should still be able to go on without this, just not with resuming
				break;
			}
			break;
		case "MKD":
		case "SITE CHMOD":
		case "RNTO":
		case "DELE":
		case "RMD":
			if (returnCode != 2)
				error(buffer, true);
			else {
				if (cmd == "RMD" && sessionsmode)							// clear out of cache if it's a remove directory
					removeCacheEntry(parameter);
				eval(remember);												// do the callback function
			}
			break;
		case "CWD":
			if (returnCode != 2)											// if it's not a directory
				transfer(true);												// try to retrieve it
			else
				remoteDirTree.changeDir(parameter);							// else navigate to the directory
			break;
		case "PWD":															// gotta check for chrooted directories
			buffer = buffer.substring(buffer.indexOf("\"") + 1, buffer.lastIndexOf("\""));	// if buffer is not '/' we're chrooted
			remoteDirTree.changeDir(buffer != '/' ? buffer : gRemotePath.value);			// navigate to the directory
			break;
		case "aborted":
			break;
		case "TYPE":
		case "goodbye":														// you say yes, i say no, you stay stop...
		default:
			if (returnCode != 2)
				error(buffer, true);
			break;
	}

	isReady = true;
	if (eventQueue.length && eventQueue[0].cmd != "welcome")				// start the next command
		writeControl(eventQueue[0].cmd, eventQueue[0].parameter);
	else {
		document.getElementById('statusbytes').label = "";					// clear status bar
		document.getElementById('statusmeter').setAttribute("mode", "determined");
		document.getElementById('statusmeter').setAttribute("value", "0%");
		if (cmd.indexOf("RETR") != -1)
			localTree.refresh();
		else if (refreshmode && (cmd.indexOf("STOR") != -1 || cmd.indexOf("APPE") != -1))
			remoteTree.refresh();
	}
}
