function commas(num) {							// add commas to numbers
	num = num.toString();
	if (num.search(/\d{4}$/) == -1)
		return num;
	num = num.replace(/\d{3}$/, ",$&");
	while (num.search(/\d{4}\x2C/) != -1)
		num = num.replace(/\d{3}\x2C/, ",$&");
	return num;
}
function zeros(num) {							// pad with zeros
	num = num.toString();
	if (num.length == 1)
		num = "0" + num;
	return num;
}
function setInterfaceMode() {					// update the interface based on collapsing
	interfacemode = (document.getElementById('leftsplitter').getAttribute('state') == 'collapsed') * 2 +
		(document.getElementById('rightsplitter').getAttribute('state') == 'collapsed')
	savePreferences();
	
	updateInterface();
}
function updateInterface() {					// update the interface based on interfacemode variable
	var local = (interfacemode & 2);
	var remote = (interfacemode & 1);
	
	document.getElementById('leftsplitter').setAttribute('state', (local ? 'collapsed' : 'open'));
	document.getElementById('rightsplitter').setAttribute('state', (remote ? 'collapsed' : 'open'));
	
	document.getElementById('leftsplitter').setAttribute('collapse', (remote ? 'none' : 'before'));
	document.getElementById('rightsplitter').setAttribute('collapse', (local ? 'none' : 'after'));
	
	document.getElementById('leftgrippy').collapsed = remote;
 	document.getElementById('retrbutton').collapsed = remote;
	document.getElementById('rightgrippy').collapsed = local;
	document.getElementById('storbutton').collapsed = local;
}


var localPathFocus;								// these functions are to keep the correct value in the paths
function onLocalPathFocus(event) {
	localPathFocus = gLocalPath.value;
}
function onLocalPathBlur(event) {
	gLocalPath.value = localPathFocus;
}
var remotePathFocus;
function onRemotePathFocus(event) {
	remotePathFocus = gRemotePath.value;
}
function onRemotePathBlur(event) {
	gRemotePath.value = remotePathFocus;
}

function browseLocal() {						// browser the local file structure
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, strbundle.getString("selectFiles"), nsIFilePicker.modeGetFolder);
	var res = fp.show();
	if (res == nsIFilePicker.returnOK)
		localDirTree.changeDir(fp.file.path);
}
function parseSize(size) {						// adds byte information for file sizes
	if (size > 1024 * 1024 * 1024)
		size = parseFloat(size / 1024 / 1024 / 1024).toFixed(1) + " GB";
	else if (size > 1024 * 1024)
		size = parseFloat(size / 1024 / 1024).toFixed(1) + " MB";
	else if (size > 1024)
		size = parseFloat(size / 1024).toFixed(1) + " KB";
	else
		size = size + " Bytes";
	return size;
}

function displayWelcomeMessage() {
	if (welcomemode)
		window.openDialog("chrome://fireftp/content/welcomeDialog.xul","welcomeDialog",
				"screenY="+(document.getElementById('main-window').boxObject.height/2 - 100+document.getElementById('main-window').boxObject.screenY)
			  +",screenX="+(document.getElementById('main-window').boxObject.width/2 - 200+document.getElementById('main-window').boxObject.screenX)+
				",width=400,height=200,chrome,modal=no,dialog=yes,resizable=yes", welcomeMessage);
}

// initializes the drag event
var whataDrag = Components.classes["@mozilla.org/widget/dragservice;1"].getService(Components.interfaces.nsIDragService);
var dragSessionEnabled = false;
function onDragGesture(event, ignore)
{
	if ((!isConnected && event.target.getAttribute("id").indexOf("remote") != -1) || (!dragSessionEnabled && !ignore))
		return;

	if (ignore) {
		var row = {};		var col = {};		var child = {};
		if (event.target.getAttribute("id") == "localdirtreechildren") {
			gLocalDirTree.treeBoxObject.getCellAt(event.pageX, event.pageY, row, col, child);
			if (!gLocalDirTree.view.getCellText(row.value, "localdirname"))		// can't drag nothing
				return;
		} else {
			gRemoteDirTree.treeBoxObject.getCellAt(event.pageX, event.pageY, row, col, child);
			if (!gRemoteDirTree.view.getCellText(row.value, "remotedirname"))	// can't drag nothing
				return;
		}
	}

	var transArray = Components.classes["@mozilla.org/supports-array;1"].createInstance(Components.interfaces.nsISupportsArray);
	var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);

	trans.addDataFlavor("text/unicode");
	var origin = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
	origin.data = event.target.getAttribute("id");
	trans.setTransferData("text/unicode", origin, origin.data.length * 2);
	transArray.AppendElement(trans.QueryInterface(Components.interfaces.nsISupports));
	whataDrag.invokeDragSession(event.target, transArray, null, whataDrag.DRAGDROP_ACTION_MOVE);
	event.preventBubble();
}
