function readPreferences() {
	try {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var prefBranch = prefs.getBranch("fireftp.");
		if (!prefBranch.prefHasUserValue("welcomemode"))
			savePreferences(true);															// preferences are null - set them for the first time
		if (!prefBranch.prefHasUserValue("filemode")) {	// update from version 0.82 (le original)
			prefBranch.setIntPref("filemode", 0);
			prefBranch.setCharPref("asciifiles", "ai,bas,bat,c,cc,cgi,conf,cpp,css,diz,eps,h,htm,html,hqx,java,map,nfo,pas,php,pl,ps,py,sh,shtml,txt,uue,xml");
			prefBranch.setIntPref("loadmode", 1);
		}
		if (!prefBranch.prefHasUserValue("logmode"))	// update from previous version
			prefBranch.setBoolPref("logmode", true);
		if (!prefBranch.prefHasUserValue("pasvmode"))	// update from previous version
			prefBranch.setBoolPref("pasvmode", true);
		if (!prefBranch.prefHasUserValue("debugmode"))	// update from previous version
			prefBranch.setBoolPref("debugmode", false);
		if (!prefBranch.prefHasUserValue("proxymode"))	// update from previous version
			prefBranch.setBoolPref("proxymode", false);
		if (!prefBranch.prefHasUserValue("uploadmode"))	// update from previous version
			prefBranch.setBoolPref("uploadmode", false);

		welcomemode = prefBranch.getBoolPref("welcomemode");
		errormode = prefBranch.getBoolPref("errormode");
		refreshmode = prefBranch.getBoolPref("refreshmode");
		passwordmode = prefBranch.getBoolPref("passwordmode");
		sessionsmode = prefBranch.getBoolPref("sessionsmode");
		hiddenmode = prefBranch.getBoolPref("hiddenmode");
		interfacemode = prefBranch.getIntPref("interfacemode");
		sslmode = prefBranch.getBoolPref("sslmode");
		pasvmode = prefBranch.getBoolPref("pasvmode");
		network = prefBranch.getIntPref("network");
		timeoutmode = prefBranch.getBoolPref("timeoutmode");								// read preferences
		retry = prefBranch.getIntPref("retry");
		attempts = prefBranch.getIntPref("attempts");
		port = prefBranch.getIntPref("port");
		destructmode = prefBranch.getBoolPref("destructmode");
		filemode = prefBranch.getIntPref("filemode");
		loadmode = prefBranch.getIntPref("loadmode");
		logmode = prefBranch.getBoolPref("logmode");
		debugmode = prefBranch.getBoolPref("debugmode");
		proxymode = prefBranch.getBoolPref("proxymode");
		uploadmode = prefBranch.getBoolPref("uploadmode");
		gLocalPath.value = prefBranch.getCharPref("folder");

		updateInterface();

		document.getElementById('cmdlog').collapsed = !logmode;
		document.getElementById('logsplitter').state = logmode ? '' : 'collapsed';			// update log view
		document.getElementById('logbutton').checked = logmode;

		var transferTypes = new Array("Auto", "Binary", "ASCII");
		document.getElementById('statustype').label = transferTypes[filemode];				// update file mode

		var asciiFiles = prefBranch.getCharPref("asciifiles");								// create ascii type list
		asciiFiles = asciiFiles.split(",");
		for (var x = 0; x < asciiFiles.length; ++x)
			prefAsciiFiles.push(asciiFiles[x]);
	} catch (ex) { debug(ex,7); }
}
function savePreferences(firstTime) {
	try {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
    		getService(Components.interfaces.nsIPrefService);
		var prefBranch = prefs.getBranch("fireftp.");

		if (firstTime) {
			prefBranch.setBoolPref("welcomemode", true);
			prefBranch.setBoolPref("errormode", true);
			prefBranch.setBoolPref("refreshmode", true);
			prefBranch.setBoolPref("passwordmode", true);
			prefBranch.setBoolPref("sessionsmode", true);
			prefBranch.setBoolPref("hiddenmode", false);
			prefBranch.setIntPref("interfacemode", 0);
			prefBranch.setBoolPref("sslmode", false);										// default settings
			prefBranch.setBoolPref("pasvmode", true);
			prefBranch.setIntPref("network", 30);
			prefBranch.setBoolPref("timeoutmode", true);
			prefBranch.setIntPref("retry", 10);
			prefBranch.setIntPref("attempts", 40);
			prefBranch.setIntPref("port", 21);
			prefBranch.setBoolPref("destructmode", false);
			prefBranch.setIntPref("filemode", 0);
			prefBranch.setCharPref("asciifiles", "ai,bas,bat,c,cc,cgi,conf,cpp,css,diz,eps,h,htm,html,hqx,java,map,nfo,pas,php,pl,ps,py,sh,shtml,txt,uue,xml");
			prefBranch.setIntPref("loadmode", 1);
			prefBranch.setBoolPref("logmode", true);
			prefBranch.setBoolPref("debugmode", false);
			prefBranch.setBoolPref("proxymode", false);
			prefBranch.setBoolPref("uploadmode", false);

			var file = Components.classes["@mozilla.org/file/directory_service;1"].
					createInstance(Components.interfaces.nsIProperties).
					get("Home", Components.interfaces.nsIFile);
			if (file.path.indexOf('/') != -1)
				prefBranch.setCharPref("folder", file.path.substring(0, file.path.indexOf('/') + 1));
			else if (file.path.indexOf('\\') != -1)
				prefBranch.setCharPref("folder", file.path.substring(0, file.path.indexOf('\\') + 1));
		} else {
			prefBranch.setIntPref("filemode", filemode);
			prefBranch.setCharPref("folder", gLocalPath.value);
			prefBranch.setBoolPref("logmode", logmode);
			prefBranch.setIntPref("interfacemode", interfacemode);
		}
	} catch (ex) { debug(ex,8); }
}
function showPreferences() {																// preferences button
	var windowHeight = document.getElementById('main-window').boxObject.height;
	var windowWidth = document.getElementById('main-window').boxObject.width;
	var windowScreenX = document.getElementById('main-window').boxObject.screenX;
	var windowScreenY = document.getElementById('main-window').boxObject.screenY;

	var hiddenCheckboxChange = new Object();
	hiddenCheckboxChange.value = 0;

	window.openDialog("chrome://fireftp/content/preferencesDialog.xul","preferencesDialog",
			"screenY="+(windowHeight/2 - 175 + windowScreenY)+",screenX="+(windowWidth/2 - 200+windowScreenX)+
			",width=400,height=350,chrome,modal=yes,dialog=yes,resizable=yes", hiddenCheckboxChange);
	readPreferences();
	if (!hiddenCheckboxChange.value)
		return;
	if (!hiddenmode) {
		var fileSpec = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
		fileSpec.initWithPath(gLocalPath.value);
		var hiddenFound = false;
		while (true) {
			if (fileSpec.isHidden() && fileSpec.path != localDirTree.data[0].path()) {
				hiddenFound = true;
				break;
			}
			if (!(parent in fileSpec) || fileSpec.path == fileSpec.parent.path)
				break;
			fileSpec = fileSpec.parent;
		}
		if (hiddenFound)
			gLocalPath.value = localDirTree.data[0].path();
	}
	localDirTree.data = new Array;
	localDirTree.treebox.rowCountChanged(0, -localDirTree.rowCount);
	localDirTree.rowCount = 0;
	localDirTree.changeDir(gLocalPath.value);
}
