var remoteDirTree = {
    data : new Array,
    rowCount : 0,
    getCellText : function(row,column) {		// names for the directories
		if (row == 0)
			return "/";
		return row == -1 ? "" : this.data[row].leafName;
    },
	getImageSrc: function(row,col) {			// icons for the directories
		return this.isContainerOpen(row) ? "res/directoryopen.ico" : "res/directory.ico";
	},
	getLevel:function(row) {					// level is based on number of slashes in the path
		 if (row <= 0 || row >= this.data.length)
			 return 0;
		 return this.data[row].path().match(/\x2f/g).length;
	},
	getParentIndex: function(row) {
		if (row <= 0)
			return -1;
		return this.indexOfPath(this.data[row].parent);
	},
	getCellProperties	: function(row,col,props)	{},
    getColumnProperties	: function(colid,col,props)	{},
    getRowProperties	: function(row,props)		{},
 	hasNextSibling		: function(row,nextrow)		{ return this.data[row].hasNext; },
	isContainer			: function(row)				{ return true; },
 	isContainerEmpty	: function(row)				{ return this.data[row].empty; },
	isContainerOpen		: function(row)				{ return this.data[row].open; },
	isSeparator			: function(row)				{ return false; },
    isSorted			: function(row)				{ return false; },
    setTree				: function(treebox)			{ this.treebox = treebox; },
	toggleOpenState		: function(row)				{
		if (this.isContainerOpen(row)) {
			if (checkIsListing())
				return;
			var level = this.getLevel(row);
			var lastChild = row;
			while (lastChild + 1 < this.rowCount && this.getLevel(lastChild + 1) > level)		// find last index in same level as collapsed dir	
				++lastChild;
			this.data[row].children = this.data.splice(row + 1, lastChild - row);				// get rid of subdirectories from view
			this.rowCount = this.data.length;
			this.treebox.rowCountChanged(row, -(lastChild - row));

			this.data[row].open = false;
			this.treebox.invalidateRow(row);													// update row

			if (gRemotePath.value.indexOf(this.data[row].path()) != -1
					&& gRemotePath.value != this.data[row].path()) {							// we were in a subdirectory and we collapsed
				gRemotePath.value = this.data[row].path();
				remoteTree.updateView();
				this.selection.select(row);
				this.treebox.ensureRowIsVisible(row);
			} else if (gRemotePath.value == this.data[row].path()) {
				this.selection.select(row);
				this.treebox.ensureRowIsVisible(row);
			}
		} else {
			if (checkIsListing())
				return;
			if (this.data[row].children) {														// stored from before
				for (var x = this.data[row].children.length - 1; x >= 0; --x)
					this.data.splice(row + 1, 0, this.data[row].children[x]);
				this.rowCount = this.data.length;
				this.treebox.rowCountChanged(row + 1, this.data[row].children.length);
				this.data[row].children = null;
				this.data[row].open = true;
				this.treebox.invalidateRow(row);
			} else {																			// get data for this directory
				list(this.data[row].path(), "remoteDirTree.toggleOpenState2(" + row + ")", false);
			}
		}
	},
	toggleOpenState2 : function(row) {
		var newDirectories = new Array();
		for (var x = 0; x < data.length; ++x)											// pick out the directories
			if (data[x].isDirectory)
				newDirectories.push(data[x]);

		if (newDirectories.length == 0)	{												// no subdirectories
			this.data[row].empty = true;
			this.data[row].open = false;
		} else {																		// has subdirectories
			for (var x = 0; x < newDirectories.length; ++x)
				newDirectories[x] = { leafName: newDirectories[x].leafName, parent: this.data[row].path(),
									  path: function() { return this.parent + (this.parent != "/" ? "/" : "") + this.leafName; },
									  open: false, empty: false, children: null, hasNext: true };

			newDirectories.sort(directorySort);
			newDirectories[newDirectories.length - 1].hasNext = false;	// last one doesn't have a next
			for (var x = newDirectories.length - 1; x >= 0; --x)
				this.data.splice(row + 1, 0, newDirectories[x]);
			this.rowCount = this.data.length;
			this.treebox.rowCountChanged(row + 1, newDirectories.length);
			this.data[row].open = true;
		}
		this.treebox.invalidateRow(row);

		if (this.updateViewAfter) {
			this.updateViewAfter = false;
			remoteTree.updateView();
		}
	},
	
	// ************************************************* mouseEvent *****************************************************

	click : function(event) {
		if (event.button == 0 || event.button == 2) {
			var row = {};		var col = {};		var child = {};
			this.treebox.getCellAt(event.pageX, event.pageY, row, col, child);
			var index = this.selection.currentIndex;

			if (index == row.value && this.data[index].path() != gRemotePath.value)					// index == row.value in case were collapsing the folder
				this.changeDir(this.data[index].path());
		} else if (event.button == 1 && !document.getElementById('remotePasteContext').disabled)	// middle-click paste
			this.paste();
	},

	// ************************************************* keyEvent *****************************************************

	remoteDirKeyDownIndex	: -1,
	remoteDirKeyDownOpen	: -1,
	keyDown  : function(event) {
		if (!isConnected)
			return;
		this.remoteDirKeyDownIndex = this.selection.currentIndex;
		this.remoteDirKeyDownOpen = this.data[this.remoteDirKeyDownIndex].open;
	},
	keyPress : function(event) {
		if (!isConnected)
			return;
		var index = this.selection.currentIndex;
		switch (event.keyCode) {
			case 37:										// left arrow
				if (!this.data[index].open && this.getParentIndex(index) != -1) {
					gRemotePath.value = this.data[this.getParentIndex(index)].path();
					remoteTree.updateView();
					this.selection.select(index);
				}
				break;
			case 38:										// up arrow
			case 40:										// down arrow
				if (event.keyCode == 38 && !index)
					return;
				if (event.keyCode == 40 && index == this.data.length - 1) {
					this.selection.select(index - 1);		// this shouldn't work but it does
					return;
				}
				var x = event.keyCode == 38 ? -1 : 1;

				gRemotePath.value = this.data[index + x].path();
				remoteTree.updateView();
				this.selection.select(index);
				break;
			case 39:										// right arrow
				if (this.remoteDirKeyDownOpen && !this.data[index].empty) {
					gRemotePath.value = this.data[index + 1].path();
					remoteTree.updateView();
				}
				break;
			case 8:											// backspace
				this.cdup();
				break;
			case 116: 										// F5
				event.preventDefault();
				remoteTree.refresh();
				break;
			case 113: 										// F2
				this.rename();
				break;
			case 46: 										// delete
				this.remove();
				break;
			case 93: 										// display context menu
				var x = {};		var y = {};		var width = {};		var height = {};
				this.treebox.getCoordsForCellItem(index, "remotedirname", "text", x, y, width, height);
				document.getElementById('remotedirmenu').showPopup(
						gRemoteDirTreeChildren, gRemoteDirTreeChildren.boxObject.x + 75, gRemoteDirTreeChildren.boxObject.y + y.value + 5, "context");
				break;
		}
		if (event.ctrlKey) {
			switch (event.charCode) {
				case 120:									// ctrl-x
					event.preventDefault();
					this.cut();
					break;
				case 118:									// ctrl-v
					event.preventDefault();
					this.paste();
					break;
				case 112:
					event.preventDefault();					// ctrl-p
					this.showProperties();
					break;
			}
		}
	},

	// ********************************************** file functions ***************************************************

	indexOfPath : function(path) {	// binary search to find a path in the remoteDirTree
		var left = 0;
		var right = this.data.length - 1;
		path = path.toLowerCase();

		while (left <= right) {
			var mid = Math.floor((left + right) / 2);
			var dataPath = this.data[mid].path().toLowerCase();
			if (dataPath == path)
				return mid;
			else if (path < dataPath)
				right = mid - 1;
			else if (path > dataPath)
				left = mid + 1;
		}
		return -1;
	},
	reselectCurrentDirectory : function() {
		var index = this.indexOfPath(gRemotePath.value);							// reselect the current directory
		this.selection.select(index);
		this.treebox.ensureRowIsVisible(index);
	},

	// ************************************************* cdup *****************************************************

	cdup : function() {
		var parentIndex = this.getParentIndex(this.selection.currentIndex);
		if (parentIndex != -1) {
			this.changeDir(this.data[parentIndex].path());
			this.selection.select(parentIndex);
		}
	},

	// ************************************************* change directories *****************************************************

	updateViewAfter : false,
	changeDir : function (path) {
		for (var x = 0; x < eventQueue.length; ++x)
			if (eventQueue[x].cmd.indexOf("LIST") != -1)
				return;
					
		gRemotePath.value = path;
		if (remoteDirTree.data.length == 0) {														// if dirTree is empty
			var oldRowCount = remoteDirTree.rowCount;
			remoteDirTree.data = new Array;
			remoteDirTree.rowCount = 0;
			remoteDirTree.treebox.rowCountChanged(0, -oldRowCount);

			remoteDirTree.data.push( {leafName: "/", parent: "",									// restart the tree
									 path: function() { return this.parent + this.leafName; },
									 open: false, empty: false, children: null, hasNext:false} );
			remoteDirTree.rowCount = 1;
			remoteDirTree.treebox.rowCountChanged(0, 1);
			remoteDirTree.selection.select(0);
		}

		// error checking here for correct values in path
		gRemotePath.value = gRemotePath.value.replace(/\x5c/g, "/");	// shouldn't have backslashes
		if (gRemotePath.value != '/' && gRemotePath.value.charAt(gRemotePath.value.length - 1) == '/')// cannot end with '\' ruins levels in dir tree
			gRemotePath.value = gRemotePath.value.substring(0, gRemotePath.value.length - 1);
		if (gRemotePath.value.charAt(0) != '/')	// has to start with '/'
			gRemotePath.value = '/' + gRemotePath.value;

		var index = this.indexOfPath(gRemotePath.value);											// find directory in remoteDirTree if it's there
		if (index != -1) {
			remotePathFocus = gRemotePath.value;																	// directory approved
			var gFormHistory = Components.classes["@mozilla.org/satchel/form-history;1"]			// add directory to drop down list
				.getService(Components.interfaces.nsIFormHistory);
			gFormHistory.addEntry(gRemotePath.getAttribute("autocompletesearchparam"), gRemotePath.value);

			if (!this.data[index].open && !this.data[index].empty) {
				this.updateViewAfter = true;
				this.toggleOpenState(index);
			} else
				remoteTree.updateView();
			return;
		}

		for (var x = 0; x < remoteDirTree.data.length; ++x)											// else we have to open parent directories til we find it
			if (gRemotePath.value.indexOf(remoteDirTree.data[x].path()) != -1) {
				if (!remoteDirTree.data[x].open)
					remoteDirTree.toggleOpenState(x);
				if (gRemotePath.value == remoteDirTree.data[x].path()) {
					remotePathFocus = gRemotePath.value;															// directory approved
					var gFormHistory = Components.classes["@mozilla.org/satchel/form-history;1"]	// add directory to drop down list
							.getService(Components.interfaces.nsIFormHistory);
					gFormHistory.addEntry(gRemotePath.getAttribute("autocompletesearchparam"), gRemotePath.value);

					if (!remoteDirTree.data[index].open && !this.data[index].empty) {
						this.updateViewAfter = true;
						remoteDirTree.toggleOpenState(index);
					} else
						remoteTree.updateView();
					return;
				}
			}

		// we haven't found the directory in the conventional sense: don't freak out, just create directories above as if it were there and list
		remotePathFocus = gRemotePath.value;
		this.treebox.rowCountChanged(0, -this.rowCount);
		this.rowCount = 0;
		this.data = new Array();
		this.data.push( {leafName: "/", parent: "",									// restart the tree
						 path: function() { return this.parent + this.leafName; },
						 open: true, empty: false, children: null, hasNext:false} );

		var paths = gRemotePath.value.split("/");
		var parentDir = "/";
		for (var x = 0; x < paths.length; ++x) {
			if (paths[x] != "") {
				this.data.push( {leafName: paths[x], parent: parentDir,
					 			 path: function() { return this.parent + (this.parent != "/" ? "/" : "") + this.leafName; },
								 open: true, empty: false, children: null, hasNext: false } );
				parentDir += (parentDir != "/" ? "/" : "") + paths[x];
			}
		}

		this.data[this.data.length - 1].open = false;								// make last directory closed

		this.rowCount = this.data.length;											// update tree
		this.treebox.rowCountChanged(0, this.rowCount);
		this.selection.select(this.rowCount - 1);

		this.updateViewAfter = true;												// open up the last directory
		this.toggleOpenState(this.data.length - 1);
	},
};
